apiVersion: batch/v1
kind: Job
metadata:
  labels:
    imagesref: "{{ config_hash }}"
    {{ network_policy_deployment_label }}: ops-imagesync
  name: {{ sync_name }}-init
  namespace: {{ namespace }}
spec:
  backoffLimit: 10
  completions: 1
  parallelism: 1
  template:
    metadata:
      labels:
        name: {{ sync_name }}
    spec:
{% if k8s_flavor == 'openshift' %}
      automountServiceAccountToken: true
{% else %}
      automountServiceAccountToken: false
{% endif %}
      containers:
      - args:
        - -c
        - |
{% if do_debugs %}
            set -x
{% endif %}
            while read sourcereg sourceimg targetreg targetimg;
            do
                if test -z "$sourcereg" -o -z "$sourceimg" -o -z "$targetreg" -o -z "$targetimg"; then
                    echo "Skipping invalid entry $sourcereg/$sourceimg/$targetreg/$targetimg"
                    continue
                fi
                sourceauth=
                sourceproto=--dest-tls-verify=true
                sourcetoken=
                sourceuser=
                targetauth=
                targetproto=--dest-tls-verify=true
                targettoken=
                targetuser=
                if test "$sourcereg" = internal; then
                    sourcereg={{ docker_registry }}
{% if k8s_flavor == 'openshift' %}
                    sourcetoken=`cat /var/run/secrets/kubernetes.io/serviceaccount/token`
                    sourceuser={{ sync_name }}
{% else %}
                    sourceproto=--dest-tls-verify=false
{% endif %}
                fi
                if test "$targetreg" = internal; then
                    targetreg={{ docker_registry }}
{% if k8s_flavor == 'openshift' %}
                    targettoken=`cat /var/run/secrets/kubernetes.io/serviceaccount/token`
                    targetuser={{ sync_name }}
{% else %}
                    targetproto=--dest-tls-verify=false
{% endif %}
                fi
                if test "$targettoken" -a "$targetuser"; then
                    dstauth="--dest-creds $targetuser:$targettoken"
                fi
                if test "$sourcetoken" -a "$sourceuser"; then
                    srcauth="--src-creds $sourceuser:$sourcetoken"
                fi
                if test -s /last/missing; then
                    if ! grep $sourcereg/$sourceimg /last/missing >/dev/null; then
                        echo "Skipping $sourcereg/$sourceimg: already synced"
                        continue
                    fi
                fi
                echo "Syncing $sourcereg/$sourceimg to $targetreg/$targetimg"
                if ! skopeo copy $sourceproto $targetproto $srcauth $dstauth \
                        docker://$sourcereg/$sourceimg \
                        docker://$targetreg/$targetimg; then
                    echo Failed pushing image to $targetreg/$targetimg
                    echo $sourcereg/$sourceimg >>/tmp/missing
                fi
            done </config/sync.conf
            if test -s /tmp/missing; then
                echo "Some images failed to sync, will try again later..."
                echo "Failed images:"
                rm -f /last/missing
                cat /tmp/missing | tee -a /last/missing
                exit 1
            fi
        command:
        - /bin/sh
        env:
{% if proxy_host | default(False) %}
        - name: http_proxy
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: https_proxy
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: no_proxy
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
        - name: HTTP_PROXY
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: HTTPS_PROXY
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
        - name: http_proxy
          value: {{ squid_address }}
        - name: https_proxy
          value: {{ squid_address }}
        - name: no_proxy
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
        - name: HTTP_PROXY
          value: {{ squid_address }}
        - name: HTTPS_PROXY
          value: {{ squid_address }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% else %}
        - name: http_proxy
          value: ""
        - name: https_proxy
          value: ""
        - name: no_proxy
          value: ""
        - name: HTTP_PROXY
          value: ""
        - name: HTTPS_PROXY
          value: ""
        - name: NO_PROXY
          value: ""
{% endif %}
        image: {{ tekton_skopeo_image }}
        imagePullPolicy: {{ pull_policy }}
        name: sync-job
        resources:
          limits:
            cpu: "{{ sync_skopeo_cpu_limit }}"
            memory: {{ sync_skopeo_memory_limit }}
          requests:
            cpu: "{{ sync_skopeo_cpu_request }}"
            memory: {{ sync_skopeo_memory_request }}
        volumeMounts:
        - mountPath: /config/sync.conf
          name: config
          subPath: {{ sync_name }}.conf
        - mountPath: /last
          name: temp
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
      restartPolicy: OnFailure
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-jobs
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
      securityContext:
        runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
      serviceAccountName: {{ sync_name if (k8s_flavor == 'openshift') else 'default' }}
{% if job_allow_unschedulable | default(True) %}
      tolerations:
      - operator: Exists
{% else %}
      tolerations: {}
{% endif %}
      volumes:
      - configMap:
          name: sync-images-tag
        name: config
      - emptyDir: {}
        name: temp
